#ifndef _CHOICEVIEW_H_
#define _CHOICEVIEW_H_

#include <nds.h>
#include "script.h"
#include "text.h"

class VNDS;

const int MAX_CHOICES = 20;
const int LABEL_LEN = 256;

class ChoiceView {
    private:
        VNDS* vnds;
        bool inited;
        bool backgroundDirty;
        int selected;
        int choiceL;        

        char* labels[MAX_CHOICES];
        u16* cursor;
        u16* background;
        int scrollY;
        
        int pad;
        int fontSize;
        
        void Update();

    public:
        ChoiceView(VNDS* vnds);
        ~ChoiceView();
        
        void ShowChoice(Command cmd);
        void Destroy();
        void DrawBackground(Text* text);
        void Draw(u16* screen, Text* text);
        bool IsActive();
};

#endif
