#include <nds.h>
#include <fat.h>
#include <unistd.h>
#include <stdlib.h>
#include <time.h>

#include "aac.h"
#include "as_lib9.h"
#include "vnwifi.h"
#include "vnselect.h"
#include "vnds.h"

int main(int argc, char** argv) {
	powerON(POWER_ALL);

    //Init Wifi & IRQ
    bool enableWifi = false;
    if (enableWifi) {
        initWifi();
    } else {
        REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_RECV_IRQ;
        irqInit();
    	irqEnable(IRQ_VBLANK);
    }

    srand(time(NULL));
    fatInitDefault();
    
    //Timer0 + Timer1 are used by as_lib
    //Timer2 is for AAC
    //Timer3 is for Wifi
    InitAACPlayer();
    
    //Init ASLib
   	IPC_Sound->mp3.helixbuffer = (u32)malloc(64 * 1024);
	AS_Init(AS_MODE_MP3);
    AS_SetDefaultSettings(AS_ADPCM, 22050, 0);
    AS_SetMP3Volume(64);
    
    chdir("/vnds");
    while (true) {
        VNSelect* vns = new VNSelect();
        vns->Run();
        delete vns;
        
        VNDS* vnds = new VNDS();
        vnds->Run();
        delete vnds;
    }

    return 0;
}
