#ifndef _SCRIPT_H_
#define _SCRIPT_H_

#include <stdio.h>
#include <string.h>
#include "dsunzip.h"
#include "filehandle.h"

/*
 * command list:
 * bgload <path>
 * setimg <image> <x> <y>
 * playsound <path>
 * bgmusic <path>
 * text <text>
 *      @ in text indicates clickless, | for linebreaks
 * choice <opt1>:<link>|<opt2>:<link>|etc...
 * setvar <var> = <value>
 * if <var> == <value>
 */



enum {
    NUMBER = 1,
    STRING = 2
};

struct Variable {
    int type;
    //union {
        int number;
        char string[128];
    //};
};



enum {
    BGLOAD,
    SETIMG,
    CLEARIMG,
    SOUND,
    MUSIC,
    TEXT,
    CLEARTEXT,
    CHOICE,
    SETVAR,
    GSETVAR,
    IF,
    FI,
    JUMP,
    DELAY,
    RANDOM,
    SKIP
};

union Command {
    int id;
    struct {
        int id;
        char path[128];
        //char trans[64];
    } bgload;
    struct {
        int id;
        char path[128];
        int x, y;
    } setimg;
    struct {
        int id;
        char path[128];
        int times; // looping
    } sound;
    struct {
        int id;
        char path[128];
    } music;
    struct {
        int id;
        char text[1024]; // more than enough for just a line of text
    } text;
    struct {
        int id;
        int numopt;
        char options[10][128];
    } choice;
    struct {
        int id;
        char name[64];
        char op;
        char value[128];
        //Variable value;
    } setvar;
    struct {
        int id;
        char name[64];
        char op[4];
        char name2[64];
    } vif;
    struct {
        int id;
        char path[128];
    } jump;
    struct {
        int id;
        int time;
    } delay;
    struct {
        int id;
        char name[64];
        int low;
        int high;
    } random;
    
};

class Script {
    private:
        int scrindex;
        char* script;
        char path[128];
        
        FileHandle* fh;
        
        int rindex;
        int filesize;
        bool empty;
        
    public:
        Script(Archive* archive, char* filename);
        ~Script();
        
        const char* GetScript();
        
        Command NextCommand();
};

#endif /* _SCRIPT_H_ */
