#include "vnimage.h"

#include <stdlib.h>

#include "filehandle.h"

bool LoadImage(char* filename, u16* out, int w, int h) {
    FileHandle* fh = fhOpen(filename);
    if (!fh) {
        return false;
    }
    
    char* data = new char[fh->length];
    fhReadFully(data, fh);

    bool result = LoadImage(filename, data, fh->length, out, w, h);
    
    delete[] data;
    fhClose(fh);
    
    return result;
}
bool LoadImage(char* filename, char* data, int dataL, u16* out, int w, int h) {
    int L = strlen(filename);
    if (L > 3 && (filename[L - 3] == 'j' || filename[L - 3] == 'J')) {
        return JPGLoadImage(data, dataL, out, w, h);
    } else {
        return PNGLoadImage(data, dataL, out, NULL, w, h);
    }
    return false;
}
