#ifndef _VNSELECT_H_
#define _VNSELECT_H_

#include <nds.h>
#include <fat.h>
#include <sys/dir.h>
#include <unistd.h>

#include "text.h"
#include "sound.h"
#include "vncommon.h"

const int MAXVNS = 11;

/*struct Snd {
    char path[64];
    char* data;
    int len;
};*/

class VNSelect {
    private:
        u16* videobuf_main;
        u16* videobuf_sub;

        u16 screen_top[256*192];
        u16 screen_btm[256*192];

        u16 topbg[256*192];
        u16 btmbg[256*192];
        u16 about[256*192];
        u16 thumbnail[75*100];

        bool aboutscreen;
        bool run;
        char novellist[MAXVNS][64];
        int novels;
        int selected;

        Text* text;
        //Sound* sound;

        bool InRect(Rect, int, int);
        Rect vnrect[MAXVNS];
        Rect selectvn;
        Rect rabout;

        void VideoInit();
        void DrawImage(u16*, char*, int, int);
        void LoadNovels();
        void TouchPad();
        void HandleInput();
        void DrawTopScreen();
        void DrawAboutScreen();
        void DrawMenu();

        int channel;
        char soundbuf[1024*12];
        void PlaySound(char*);

        void Select();


    public:
        VNSelect();
        ~VNSelect();

        void Run();
};

#endif /* _VNSELECT_H_ */
