#ifndef SIPC_H
#define SIPC_H

#include <nds.h>


//==============================================================================
//=== as_lib ===================================================================
//==============================================================================

#define MAX_SND_COMMANDS	32

typedef enum _SND_COMMAND_TYPE {
	SND_CMD_SETMEMPOOL,		// Param32: Address, Param[0 to 2]: Size
	SND_CMD_PLAYSONG,		// Param32: Pointer to song file (standard .mod)
	SND_CMD_STOPSONG,		// No params
	SND_CMD_PAUSESONG,		// Param[0]: 1=pause, 0=unpause
	SND_CMD_SETCALLBACK,	// Param32: MOD_CALLBACK function pointer
	SND_CMD_SETVOLUME,		// Param32: volume
	SND_CMD_NUM
} SND_COMMAND_TYPE;


// ----- Structures -----

	// Commands filled out by ARM9 to tell ARM7 what to do
typedef struct _SND_COMMAND {
	u8 cmdType;		// SND_COMMAND_TYPE enum
	u8 param[3];	// Depend on cmdType
	u32 param32;	// Mainly for commands that need to send a pointer

} SND_COMMAND;

// Processor communication area
typedef struct _SND_CONTROL {
	SND_COMMAND	cmd[MAX_SND_COMMANDS];
	u8			curCmd;
	bool   		bInitialized;	// Set by ARM9's SndInit
	bool		toFade;
} SND_CONTROL;

//==============================================================================
//==============================================================================
//==============================================================================

//IPC Memory alignment = libnds, as_lib control, as_lib data, aac_control
#define sndControl	((SND_CONTROL*)((u32)(IPC) + sizeof(TransferRegion)))

//FIFO Messages
#define COMMAND7_TOGGLE_BACKLIGHT 1
#define MSG_WIFI_INITIALIZE 0x10000001
#define MSG_WIFI_SYNC 0x10000002

#endif	// SIPC_H
